/*
 * Copyright 2022-2023 Canonical Ltd.
 *
 * SPDX-License-Identifier: GPL-3.0
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see
 * <http://www.gnu.org/licenses/>.
 */

#pragma once

#define _GNU_SOURCE

#define UNUSED(X) __attribute__((unused(X)))

typedef struct _iso_data
{
    char *label;
    char *url;
    char *sha256sum;
    int size;
} iso_data_t;

typedef struct _choices
{
    int len;
    int cur;
    iso_data_t **values;
} choices_t;

iso_data_t *iso_data_create(char *label, char *url, char *sha256sum, int size);
void iso_data_free(iso_data_t *iso_data);

choices_t *choices_create(int len);
void choices_free(choices_t *c);

char *saprintf(char *fmt, ...) __attribute__((format(printf, 1, 2)));
